﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using DragDropXamGrids;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using System.Windows.Media.Animation;


namespace XamDataGridCopyPaste
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        SelectedRecordCollection selectedRecords;
        public Window1()
        {
            InitializeComponent();
            xamDataGrid1.DataSource = EmployeeData.GenerateEmployeeData();
            xamDataGrid1.KeyDown += new System.Windows.Input.KeyEventHandler(xamDataGrid1_KeyDown);
        }

        void xamDataGrid1_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == Key.C)
            {
                if (Keyboard.Modifiers == ModifierKeys.Control)
                {
                    Infragistics.Windows.DataPresenter.DataPresenterBase.SelectedItemHolder selectedItems = xamDataGrid1.SelectedItems;
                    selectedRecords = selectedItems.Records;
                }
            }
            if (e.Key == Key.V)
            {
                if (Keyboard.Modifiers == ModifierKeys.Control)
                {
                    BindingList<Employee> dataSource = xamDataGrid1.DataSource as BindingList<Employee>;
                    foreach (DataRecord record in selectedRecords)
                    {
                        dataSource.Add(record.DataItem as Employee);                        
                    }
                    xamDataGrid1.DataSource = dataSource;

                    
                    xamDataGrid1.ExecuteCommand(DataPresenterCommands.RecordLastOverall);
                    for (int i = xamDataGrid1.Records.Count - selectedRecords.Count; i < xamDataGrid1.Records.Count; i++)
                    {
                        AnimateNewlyAdded((xamDataGrid1.Records[i] as DataRecord));
                    }
                }
                
            }
        }

        private void AnimateNewlyAdded(DataRecord record)
        {
            try
            {

                DataRecordPresenter drp = DataRecordPresenter.FromRecord(record) as DataRecordPresenter;

                drp.BeginAnimation(DataRecordPresenter.OpacityProperty, new DoubleAnimation(0, 1, new Duration(TimeSpan.FromSeconds(1))));
            }
            catch { }
        }
    }
}
